class com.KidFighting.FightTrigger
{
   static var removeEventListener;
   static var addEventListener;
   static var dispatchEvent;
   static var p1WinTimes;
   static var p2WinTimes;
   static var _evt = mx.events.EventDispatcher.initialize(com.KidFighting.FightTrigger);
   static var score = 0;
   static var player1 = null;
   static var player2 = null;
   static var delay_timer = new ds.controls.Timer();
   function FightTrigger()
   {
   }
   static function get idPlayer1()
   {
      return com.KidFighting.FightTrigger.player1.uniqueId;
   }
   static function get idPlayer2()
   {
      return com.KidFighting.FightTrigger.player2.uniqueId;
   }
   static function joinP1(chSet)
   {
      if(com.KidFighting.FightTrigger.player1 != null)
      {
         com.KidFighting.FightTrigger.removeEventListener("onResumeGame",com.KidFighting.FightTrigger.player1);
         com.KidFighting.FightTrigger.removeEventListener("onPauseGame",com.KidFighting.FightTrigger.player1);
         com.KidFighting.FightTrigger.player1.removeEventListener("onFightActivated",com.KidFighting.FightTrigger);
         com.KidFighting.FightTrigger.player1.destroy();
         com.KidFighting.FightTrigger.player1 = undefined;
      }
      com.KidFighting.FightTrigger.player1 = new chSet.cls();
      com.KidFighting.FightTrigger.player1.ani = chSet.ani;
      com.KidFighting.FightTrigger.player1.controller = null;
      com.KidFighting.Input.owner = com.KidFighting.FightTrigger.player1;
      com.KidFighting.FightTrigger.addEventListener("onResumeGame",com.KidFighting.FightTrigger.player1);
      com.KidFighting.FightTrigger.addEventListener("onPauseGame",com.KidFighting.FightTrigger.player1);
      com.KidFighting.FightTrigger.player1.addEventListener("onFightActivated",com.KidFighting.FightTrigger);
      com.KidFighting.FightTrigger.score = 0;
   }
   static function joinP2(chSet)
   {
      if(com.KidFighting.FightTrigger.player2 != null)
      {
         com.KidFighting.FightTrigger.removeEventListener("onPauseGame",com.KidFighting.FightTrigger.player2.controller);
         com.KidFighting.FightTrigger.removeEventListener("onResumeGame",com.KidFighting.FightTrigger.player2.controller);
         com.KidFighting.FightTrigger.removeEventListener("onFightStart",com.KidFighting.FightTrigger.player2.controller);
         com.KidFighting.FightTrigger.removeEventListener("onFightEnd",com.KidFighting.FightTrigger.player2.controller);
         com.KidFighting.FightTrigger.player2.controller.removeEventListener("updateInput",com.KidFighting.FightTrigger);
         delete com.KidFighting.FightTrigger.player2.controller;
         com.KidFighting.FightTrigger.removeEventListener("onResumeGame",com.KidFighting.FightTrigger.player2);
         com.KidFighting.FightTrigger.removeEventListener("onPauseGame",com.KidFighting.FightTrigger.player2);
         com.KidFighting.FightTrigger.player2.removeEventListener("onFightActivated",com.KidFighting.FightTrigger);
         if(com.KidFighting.FightTrigger.player2.brother != undefined)
         {
            com.KidFighting.FightTrigger.player2.brother.removeEventListener("onFightActivated",com.KidFighting.FightTrigger);
         }
         com.KidFighting.FightTrigger.player2.destroy();
         com.KidFighting.FightTrigger.player2 = null;
      }
      com.KidFighting.FightTrigger.player2 = new chSet.cls();
      com.KidFighting.FightTrigger.player2.ani = chSet.ani;
      var _loc1_ = new com.KidFighting.AiController();
      _loc1_.level = 10;
      com.KidFighting.FightTrigger.player2.controller = _loc1_;
      _loc1_.owner = com.KidFighting.FightTrigger.player2;
      _loc1_.addEventListener("updateInput",com.KidFighting.FightTrigger);
      com.KidFighting.FightTrigger.addEventListener("onResumeGame",com.KidFighting.FightTrigger.player2);
      com.KidFighting.FightTrigger.addEventListener("onPauseGame",com.KidFighting.FightTrigger.player2);
      com.KidFighting.FightTrigger.addEventListener("onPauseGame",com.KidFighting.FightTrigger.player2.controller);
      com.KidFighting.FightTrigger.addEventListener("onResumeGame",com.KidFighting.FightTrigger.player2.controller);
      com.KidFighting.FightTrigger.addEventListener("onFightStart",com.KidFighting.FightTrigger.player2.controller);
      com.KidFighting.FightTrigger.addEventListener("onFightEnd",com.KidFighting.FightTrigger.player2.controller);
      if(com.KidFighting.FightTrigger.player2.brother != undefined)
      {
         com.KidFighting.FightTrigger.player2.brother.addEventListener("onFightActivated",com.KidFighting.FightTrigger);
      }
      com.KidFighting.FightTrigger.player2.addEventListener("onFightActivated",com.KidFighting.FightTrigger);
   }
   static function onFightActivated(evtObj)
   {
      if(com.KidFighting.FightTrigger.player1.status == "lose" || com.KidFighting.FightTrigger.player2.status == "lose")
      {
         return undefined;
      }
      var _loc3_ = evtObj.activer;
      var _loc1_ = _loc3_.opponent;
      if(evtObj.getHurt)
      {
         if(_loc1_.status != "hurt" && _loc1_.status != "thrown")
         {
            var _loc4_ = evtObj.hurtValue != undefined ? evtObj.hurtValue : _loc3_.strength;
            if(_loc1_.crtHP - _loc4_ > 0)
            {
               _loc1_.crtHP -= _loc4_;
            }
            else
            {
               _loc1_.crtHP = 0;
            }
            if(!evtObj.isNoAnimation)
            {
               if(_loc3_.direction == "down")
               {
                  com.KidFighting.FightTrigger.updateInput({activer:_loc1_,motion:"hurtDown",hurtEff:evtObj.hitEff});
               }
               else
               {
                  com.KidFighting.FightTrigger.updateInput({activer:_loc1_,motion:"hurtUp",hurtEff:evtObj.hitEff});
               }
            }
            else if(evtObj.hurtFunc)
            {
               _loc1_[evtObj.hurtFunc]();
            }
            if(_loc3_ == com.KidFighting.FightTrigger.player1)
            {
               com.KidFighting.FightTrigger.score += _loc4_ * 15 + 40;
            }
            com.KidFighting.FightTrigger.dispatchEvent({type:"updateLife",p1Life:com.KidFighting.FightTrigger.player1.HP,p2Life:com.KidFighting.FightTrigger.player2.HP,score:com.KidFighting.FightTrigger.score});
            com.KidFighting.FightTrigger.checkWinLose();
         }
      }
      else if(_loc1_.status == "down")
      {
         com.KidFighting.FightTrigger.updateInput({activer:_loc1_,motion:"blockDown",hurtEff:evtObj.blockHitEff});
      }
      else
      {
         com.KidFighting.FightTrigger.updateInput({activer:_loc1_,motion:"blockUp",hurtEff:evtObj.blockHitEff});
      }
      com.KidFighting.FightTrigger.dispatchEvent(evtObj);
   }
   static function updateInput(evtObj)
   {
      evtObj.activer.doMotion(evtObj);
   }
   static function onFightStart(evtObj)
   {
      com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player1,motion:"normal"});
      com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player2,motion:"normal"});
      com.KidFighting.FightTrigger.dispatchEvent({type:"onFightStart"});
   }
   static function onRoundInit(evtObj)
   {
      com.KidFighting.FightTrigger.player1.setup("left");
      com.KidFighting.FightTrigger.player2.setup("right");
      com.KidFighting.FightTrigger.player1.opponent = com.KidFighting.FightTrigger.player2;
      com.KidFighting.FightTrigger.player2.opponent = com.KidFighting.FightTrigger.player1;
      if(com.KidFighting.FightTrigger.player2.brother)
      {
         com.KidFighting.FightTrigger.player2.brother.opponent = com.KidFighting.FightTrigger.player1;
      }
      if(_root.sideUpdater_mc == undefined)
      {
         _root.createEmptyMovieClip("sideUpdater_mc",_root.getNextHighestDepth());
         var o = com.KidFighting.FightTrigger;
         _root.sideUpdater_mc.onEnterFrame = function()
         {
            if(o.player1.ani._x > o.player2.ani._x)
            {
               o.player1.side = -1;
               o.player2.side = 1;
            }
            else
            {
               o.player1.side = 1;
               o.player2.side = -1;
            }
            if(o.player1.status == "normal")
            {
               o.player1.updateSide();
            }
            if(o.player2.status == "normal")
            {
               o.player2.updateSide();
            }
         };
      }
      if(evtObj.round == 1)
      {
         com.KidFighting.FightTrigger.p1WinTimes = 0;
         com.KidFighting.FightTrigger.p2WinTimes = 0;
         com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player1,motion:"intro"});
         com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player2,motion:"intro"});
      }
      else
      {
         com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player1,motion:"normal"});
         com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player2,motion:"normal"});
      }
   }
   static function onTimeOut(evtObj)
   {
      com.KidFighting.FightTrigger.checkWinLose(true);
   }
   static function checkWinLose(isTimeOut)
   {
      if(!isTimeOut && com.KidFighting.FightTrigger.player1.HP > 0 && com.KidFighting.FightTrigger.player2.HP > 0 || com.KidFighting.FightTrigger.player1.status == "win" || com.KidFighting.FightTrigger.player2.status == "win")
      {
         return undefined;
      }
      com.KidFighting.FightTrigger.delay_timer.interval = 2000;
      if(com.KidFighting.FightTrigger.player1.HP > com.KidFighting.FightTrigger.player2.HP)
      {
         com.KidFighting.FightTrigger.delay_timer.func = function()
         {
            com.KidFighting.FightTrigger.delay_timer.stop();
            com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player1,motion:"win"});
         };
         com.KidFighting.FightTrigger.p1WinTimes = com.KidFighting.FightTrigger.p1WinTimes + 1;
         com.KidFighting.FightTrigger.player1.freeze();
         if(com.KidFighting.FightTrigger.player2.HP == 0)
         {
            ds.controls.SoundPlayer.playSound("KO_" + com.KidFighting.FightTrigger.player2.sex);
         }
      }
      else
      {
         com.KidFighting.FightTrigger.delay_timer.func = function()
         {
            com.KidFighting.FightTrigger.delay_timer.stop();
            com.KidFighting.FightTrigger.updateInput({activer:com.KidFighting.FightTrigger.player2,motion:"win"});
         };
         com.KidFighting.FightTrigger.p2WinTimes = com.KidFighting.FightTrigger.p2WinTimes + 1;
         com.KidFighting.FightTrigger.player2.freeze();
         if(com.KidFighting.FightTrigger.player1.HP == 0)
         {
            ds.controls.SoundPlayer.playSound("KO_" + com.KidFighting.FightTrigger.player1.sex);
         }
      }
      com.KidFighting.FightTrigger.delay_timer.start();
      if(com.KidFighting.FightTrigger.p1WinTimes > 1 || com.KidFighting.FightTrigger.p2WinTimes > 1)
      {
         if(com.KidFighting.FightTrigger.p1WinTimes > com.KidFighting.FightTrigger.p2WinTimes)
         {
            com.KidFighting.FightTrigger.dispatchEvent({type:"endRound",roundClear:true,win:0,winnerLable:com.KidFighting.FightTrigger.player1.winLable,p1WinTimes:com.KidFighting.FightTrigger.p1WinTimes,p2WinTimes:com.KidFighting.FightTrigger.p2WinTimes,timeout:isTimeOut});
         }
         else
         {
            com.KidFighting.FightTrigger.dispatchEvent({type:"endRound",roundClear:true,win:1,winnerLable:com.KidFighting.FightTrigger.player2.winLable,p1WinTimes:com.KidFighting.FightTrigger.p1WinTimes,p2WinTimes:com.KidFighting.FightTrigger.p2WinTimes,timeout:isTimeOut});
         }
      }
      else
      {
         com.KidFighting.FightTrigger.dispatchEvent({type:"endRound",roundClear:false,p1WinTimes:com.KidFighting.FightTrigger.p1WinTimes,p2WinTimes:com.KidFighting.FightTrigger.p2WinTimes,timeout:isTimeOut});
      }
      com.KidFighting.FightTrigger.dispatchEvent({type:"onFightEnd"});
      com.KidFighting.FightTrigger.dispatchEvent({type:"updateLife",p1Life:com.KidFighting.FightTrigger.player1.HP,p2Life:com.KidFighting.FightTrigger.player2.HP,score:com.KidFighting.FightTrigger.score});
   }
   static function pauseGame(evtObj)
   {
      if(evtObj.value)
      {
         com.KidFighting.FightTrigger.dispatchEvent({type:"onPauseGame"});
      }
      else
      {
         com.KidFighting.FightTrigger.dispatchEvent({type:"onResumeGame"});
      }
   }
}
