class com.KidFighting.skills.SklDynamite extends com.KidFighting.objects.CSkill
{
   var name;
   var keys;
   var effStartFrame;
   var hurtValue;
   var type;
   var effect2;
   var effect;
   var performing;
   var owner;
   var hurtValue2 = 2;
   function SklDynamite()
   {
      super();
      this.name = "Dynamite";
      this.keys = com.KidFighting.Input.LEFT + "," + com.KidFighting.Input.LEFT + "," + com.KidFighting.Input.S;
      this.effStartFrame = 6;
      this.hurtValue = 15;
      this.type = "flyItem";
   }
   function condition()
   {
      if(this.effect2 && this.effect2.performing)
      {
         return false;
      }
      return !this.effect.performing && super.condition();
   }
   function perform()
   {
      this.performing = true;
      this.effect = com.KidFighting.EffectSys.generate(this.name,this.owner._twnF,this.owner,this.owner.ani._x + this.owner.side * 30,this.owner.orgY - 35);
      this.effect.effStartFrame = this.effStartFrame;
      this.effect.hurtValue = this.hurtValue;
      this.effect.skill = this;
      this.effect.looping = true;
      this.effect.movingSpeed = this.owner.side * this.effect.movingSpeed;
      this.effect.addEffectListener(this);
      ds.controls.SoundPlayer.playSound("BasicAttack_male");
   }
   function explode(x)
   {
      this.effect2 = com.KidFighting.EffectSys.generate("Explosion",null,this.owner,x,this.owner.orgY);
      this.effect2.owner = this.owner;
      this.effect2.hurtValue = this.hurtValue2;
      this.effect2.addEffectListener(this);
   }
   function onMotionStopped()
   {
      if(this.effect2.performing)
      {
         return undefined;
      }
      this.effect2.removeEffectListener(this);
      this.effect.removeEffectListener(this);
      this.performing = false;
      this.owner.setSkillMotionFinished(this);
   }
}
