class com.KidFighting.skills.SklFlamePunch extends com.KidFighting.objects.CSkill
{
   var name;
   var keys;
   var effStartFrame;
   var hurtValue;
   var type;
   var performing;
   var owner;
   var maxHit;
   var hit;
   function SklFlamePunch()
   {
      super();
      this.name = "FlamePunch";
      this.keys = com.KidFighting.Input.RIGHT + "," + com.KidFighting.Input.RIGHT + "," + com.KidFighting.Input.A;
      this.effStartFrame = 2;
      this.hurtValue = 30;
      this.type = "self";
   }
   function perform()
   {
      this.performing = true;
      this.owner.startInvincible(0.2);
      this.maxHit = 10;
      this.hit = false;
      this.observeCharacterTween(this.owner._twnF);
      this.onMotionFinished = this.onMotionStopped;
      ds.controls.SoundPlayer.playSound("flame_special1");
   }
   function onMotionUpdated(twn)
   {
      if(twn.obj._currentframe > this.effStartFrame)
      {
         if(!this.hit)
         {
            this.hit = this.owner.hitTest(this.owner.getInstance().hitBlock,null,this.hurtValue,null,null,true,"mtBlastHurt");
            if(this.hit)
            {
               this.maxHit = this.maxHit - 1;
               ds.controls.SoundPlayer.playSound("tin_special1_2");
            }
         }
         else if(this.maxHit-- > 0)
         {
            if(this.hit == 1)
            {
               this.owner.opponent.mtBlastHurt("Hurt");
            }
            else
            {
               this.hit = this.owner.hitTest(this.owner.getInstance().hitBlock,null,this.hurtValue,null,null,true,"mtBlastHurt");
            }
         }
      }
   }
   function onMotionStopped()
   {
      this.unobserveCharacterTween(this.owner._twnF);
      this.performing = false;
      this.owner.setSkillMotionFinished(this);
   }
}
