class com.KidFighting.skills.SklFly extends com.KidFighting.objects.CSkill
{
   var name;
   var keys;
   var effStartFrame;
   var hurtValue;
   var type;
   var performing;
   var hit;
   var movingSpeed;
   var owner;
   var characterMovingSpeed = 15;
   function SklFly()
   {
      super();
      this.name = "Fly";
      this.keys = com.KidFighting.Input.LEFT + "," + com.KidFighting.Input.RIGHT + "," + com.KidFighting.Input.A;
      this.effStartFrame = 4;
      this.hurtValue = 15;
      this.type = "self";
   }
   function perform()
   {
      this.performing = true;
      this.hit = false;
      this.movingSpeed = this.owner.side * this.characterMovingSpeed;
      this.observeCharacterTween(this.owner._twnF);
      this.onMotionFinished = this.onMotionStopped;
      ds.controls.SoundPlayer.playSound("sing_special5");
   }
   function onMotionUpdated(twn)
   {
      if(twn.obj._currentframe > this.effStartFrame)
      {
         if(!this.hit)
         {
            if(this.owner.hitTest(this.owner.getInstance().hitBlock,null,this.hurtValue,null,null,true,"mtBlastHurt"))
            {
               this.hit = true;
            }
         }
         this.owner.ani._x += this.movingSpeed;
         if(this.owner.opponent.direction != "up")
         {
            this.owner.correctPosition();
         }
         this.owner.correctOffside();
      }
   }
   function onMotionStopped()
   {
      this.unobserveCharacterTween(this.owner._twnF);
      this.performing = false;
      this.owner.setSkillMotionFinished(this);
   }
}
