class com.KidFighting.skills.SklSlice extends com.KidFighting.objects.CSkill
{
   var name;
   var keys;
   var effStartFrame;
   var hurtValue;
   var type;
   var effect;
   var performing;
   var owner;
   function SklSlice()
   {
      super();
      this.name = "Slice";
      this.keys = com.KidFighting.Input.LEFT + "," + com.KidFighting.Input.LEFT + "," + com.KidFighting.Input.S;
      this.effStartFrame = 3;
      this.hurtValue = 15;
      this.type = "flyItem";
   }
   function condition()
   {
      return super.condition() && !this.effect.performing;
   }
   function perform()
   {
      this.performing = true;
      this.owner.startInvincible(0.1);
      this.effect = com.KidFighting.EffectSys.generate(this.name,this.owner._twnF,this.owner,this.owner.ani._x + this.owner.side * 5,this.owner.orgY - 35);
      this.effect.effStartFrame = this.effStartFrame;
      this.effect.hurtValue = this.hurtValue;
      this.effect.looping = true;
      this.effect.movingSpeed = this.owner.side * this.effect.movingSpeed;
      this.effect.addEffectListener(this);
      ds.controls.SoundPlayer.playSound("tin_special2");
   }
   function onMotionStopped()
   {
      this.effect.removeEffectListener(this);
      this.performing = false;
      this.owner.setSkillMotionFinished(this);
   }
}
