class com.KidFighting.CharacterManager extends MovieClip
{
   static var _cm;
   static var charClsList = [com.KidFighting.characters.MaleFighter,com.KidFighting.characters.FemaleFighter];
   static var aniList = ["ch_maleFighter","ch_femaleFighter"];
   static var charEnemyClsList = [com.KidFighting.characters.Bone,com.KidFighting.characters.Barbor,com.KidFighting.characters.Tailor,com.KidFighting.characters.Coolie,com.KidFighting.characters.Donut,com.KidFighting.characters.BrotherSum,com.KidFighting.characters.Landlord,com.KidFighting.characters.Landlady,com.KidFighting.characters.Tim,com.KidFighting.characters.Flame];
   static var aniEnemyList = ["ch_bone","ch_barber","ch_tailor","ch_coolie","ch_donut","ch_brotherSum","ch_landlord","ch_landlady","ch_tim","ch_flame"];
   static var selectedList = [];
   function CharacterManager()
   {
      super();
      com.KidFighting.CharacterManager._cm = this;
   }
   static function generateInstance(instanceStr)
   {
      return com.KidFighting.CharacterManager._cm[instanceStr].duplicateMovieClip("fighter" + com.KidFighting.CharacterManager._cm.getNextHighestDepth(),com.KidFighting.CharacterManager._cm.getNextHighestDepth());
   }
   static function select(id)
   {
      if(isNaN(id))
      {
         id = com.KidFighting.CharacterManager.selectedList.length - 1;
      }
      if(com.KidFighting.CharacterManager.selectedList.length == com.KidFighting.CharacterManager.charEnemyClsList)
      {
         return null;
      }
      var _loc2_ = undefined;
      var _loc3_ = undefined;
      if(id >= com.KidFighting.CharacterManager.charClsList.length)
      {
         id -= com.KidFighting.CharacterManager.charClsList.length;
         _loc2_ = com.KidFighting.CharacterManager.charEnemyClsList[id];
         _loc3_ = com.KidFighting.CharacterManager._cm[com.KidFighting.CharacterManager.aniEnemyList[id]].duplicateMovieClip("fighter" + com.KidFighting.CharacterManager._cm.getNextHighestDepth(),com.KidFighting.CharacterManager._cm.getNextHighestDepth());
      }
      else
      {
         _loc2_ = com.KidFighting.CharacterManager.charClsList[id];
         _loc3_ = com.KidFighting.CharacterManager._cm[com.KidFighting.CharacterManager.aniList[id]].duplicateMovieClip("fighter" + com.KidFighting.CharacterManager._cm.getNextHighestDepth(),com.KidFighting.CharacterManager._cm.getNextHighestDepth());
      }
      com.KidFighting.CharacterManager.selectedList.push(_loc2_);
      return {cls:_loc2_,ani:_loc3_};
   }
   static function randomSelectEnemy()
   {
      return com.KidFighting.CharacterManager.select(random(com.KidFighting.CharacterManager.charClsList.length + com.KidFighting.CharacterManager.charEnemyClsList.length));
   }
   static function selectNextEnemy()
   {
      return com.KidFighting.CharacterManager.select(com.KidFighting.CharacterManager.charClsList.length + com.KidFighting.CharacterManager.selectedList.length - 1);
   }
   static function reset()
   {
      com.KidFighting.CharacterManager.selectedList = [];
   }
}
