class com.KidFighting.GameOverGUI extends MovieClip
{
   static var _sprite;
   static var isLoggedin = false;
   function GameOverGUI()
   {
      super();
      com.KidFighting.GameOverGUI._sprite = this;
      this._visible = false;
      this.gotoAndStop(1);
      com.KidFighting.Leaderboard.addListener(com.KidFighting.GameOverGUI);
      com.KidFighting.Leaderboard.loginCheck();
   }
   static function onGetLoginStatus(r)
   {
      com.KidFighting.GameOverGUI.isLoggedin = r;
   }
   static function onResetGame()
   {
      com.KidFighting.GameOverGUI._sprite._visible = false;
   }
   static function onGameOver()
   {
      com.KidFighting.GameOverGUI._sprite.gotoAndStop(1);
      com.KidFighting.GameOverGUI._sprite.movie.gotoAndPlay(1);
      com.KidFighting.GameOverGUI.show();
   }
   static function onClearStage()
   {
      com.KidFighting.GameOverGUI._sprite.gotoAndStop(2);
      com.KidFighting.GameOverGUI._sprite.movie.gotoAndPlay(1);
      com.KidFighting.GameOverGUI.show();
   }
   static function submitHighScore()
   {
      if(com.KidFighting.GameOverGUI.isLoggedin)
      {
         com.KidFighting.Leaderboard.saveScore(com.KidFighting.FightTrigger.score);
         com.KidFighting.GameOverGUI.hide();
         com.KidFighting.StartGameGUI.show();
      }
   }
   static function replay()
   {
      com.KidFighting.GameOverGUI.hide();
      com.KidFighting.StartGameGUI.show();
   }
   static function show()
   {
      com.KidFighting.GameOverGUI._sprite._visible = true;
   }
   static function hide()
   {
      com.KidFighting.GameOverGUI._sprite._visible = false;
   }
}
