class com.KidFighting.Leaderboard
{
   var xmlOutput;
   static var addListener;
   static var send_lvars;
   static var receive_lvars;
   static var broadcastMessage;
   static var _response;
   static var DATA_FEED_URL = "../../../calls/dataFeed.php";
   static var GAME_ID = 2;
   static var initialized = com.KidFighting.Leaderboard.staticIint();
   function Leaderboard()
   {
   }
   static function loginCheck()
   {
      com.KidFighting.Leaderboard.send_lvars = new LoadVars();
      com.KidFighting.Leaderboard.send_lvars.xmlInput = "<login-check-request />";
      com.KidFighting.Leaderboard.receive_lvars = new LoadVars();
      com.KidFighting.Leaderboard.receive_lvars.onLoad = function(success)
      {
         if(success)
         {
            var _loc2_ = new XML();
            _loc2_.ignoreWhite = true;
            _loc2_.parseXML(this.xmlOutput);
            if(_loc2_.firstChild.nodeName == "login-check-response" && Number(_loc2_.firstChild.attributes.code) == 0)
            {
               com.KidFighting.Leaderboard.broadcastMessage("onGetLoginStatus",true);
            }
            else
            {
               com.KidFighting.Leaderboard.broadcastMessage("onGetLoginStatus",false);
            }
         }
         else
         {
            com.KidFighting.Leaderboard.broadcastMessage("onGetLoginStatus",false);
         }
      };
      com.KidFighting.Leaderboard.send_lvars.sendAndLoad(com.KidFighting.Leaderboard.DATA_FEED_URL + "?rand=" + random(9999),com.KidFighting.Leaderboard.receive_lvars,"POST");
   }
   static function saveScore(score)
   {
      if(score == 0)
      {
         com.KidFighting.Leaderboard.handleResult(-1);
         return undefined;
      }
      com.KidFighting.Leaderboard.send_lvars = new LoadVars();
      com.KidFighting.Leaderboard.send_lvars.xmlInput = "<save-score-request gameId=\"" + String(com.KidFighting.Leaderboard.GAME_ID) + "\" score=\"" + String(score) + "\" />";
      com.KidFighting.Leaderboard.receive_lvars = new LoadVars();
      com.KidFighting.Leaderboard.receive_lvars.onLoad = function(success)
      {
         if(success)
         {
            var _loc2_ = new XML();
            _loc2_.ignoreWhite = true;
            _loc2_.parseXML(this.xmlOutput);
            com.KidFighting.Leaderboard.handleResult(Number(_loc2_.firstChild.attributes.code));
            com.KidFighting.Leaderboard.notify();
         }
         else
         {
            com.KidFighting.Leaderboard.handleResult(-1);
         }
      };
      com.KidFighting.Leaderboard.send_lvars.sendAndLoad(com.KidFighting.Leaderboard.DATA_FEED_URL + "?rand=" + random(9999),com.KidFighting.Leaderboard.receive_lvars,"POST");
   }
   static function handleResult(code, data)
   {
      com.KidFighting.Leaderboard._response(code,data);
   }
   static function notify()
   {
      var _loc1_ = new LocalConnection();
      _loc1_.send("leaderboard","onLeaderboardUpdate");
   }
   static function get onResponse()
   {
      return com.KidFighting.Leaderboard._response;
   }
   static function set onResponse(response_func)
   {
      com.KidFighting.Leaderboard._response = response_func;
   }
   static function staticIint()
   {
      AsBroadcaster.initialize(com.KidFighting.Leaderboard);
      return true;
   }
}
