class com.KidFighting.RoundGUI extends MovieClip
{
   static var addEventListener;
   static var _gui;
   static var dispatchEvent;
   static var ROUND1 = 2;
   static var ROUND2 = 3;
   static var ROUND3 = 4;
   static var TIMEOUT = 5;
   static var KO = 6;
   static var _twnF = null;
   static var _evt = mx.events.EventDispatcher.initialize(com.KidFighting.RoundGUI);
   static var _inited = com.KidFighting.RoundGUI.initialize();
   function RoundGUI()
   {
      super();
      com.KidFighting.RoundGUI._gui = this;
   }
   static function initialize()
   {
      com.KidFighting.RoundGUI._gui.gotoAndStop(1);
      com.KidFighting.RoundGUI._twnF = new ds.transitions.Tween(null,"_currentframe",null,1,1,1);
      return true;
   }
   static function getInstance()
   {
      return com.KidFighting.RoundGUI._gui.getInstanceAtDepth(-16383);
   }
   static function show(lableId, cb, isWin)
   {
      com.KidFighting.RoundGUI._gui.gotoAndStop(lableId);
      var callback = cb;
      var _loc1_ = com.KidFighting.RoundGUI.getInstance();
      com.KidFighting.RoundGUI._twnF.obj = _loc1_;
      com.KidFighting.RoundGUI._twnF.begin = 1;
      com.KidFighting.RoundGUI._twnF.finish = com.KidFighting.RoundGUI._twnF.duration = _loc1_._totalframes;
      com.KidFighting.RoundGUI._twnF.onMotionFinished = function()
      {
         callback();
      };
      com.KidFighting.RoundGUI._twnF.start();
      if(isWin != undefined)
      {
         if(isWin)
         {
            com.KidFighting.RoundGUI._gui.winSymbol_mc.gotoAndStop(1);
         }
         else
         {
            com.KidFighting.RoundGUI._gui.winSymbol_mc.gotoAndStop(2);
         }
      }
   }
   static function onRoundInit(evtObj)
   {
      if(evtObj.round == 1)
      {
         com.KidFighting.RoundGUI._twnF.stop();
         gotoAndStop(1);
      }
      com.KidFighting.RoundGUI.show(com.KidFighting.RoundGUI["ROUND" + evtObj.round],function()
      {
         com.KidFighting.RoundGUI.dispatchEvent({type:"fightStart"});
      }
      );
   }
   static function onRoundEnd(evtObj)
   {
      if(evtObj.winnerLable == undefined)
      {
         if(evtObj.timeout)
         {
            com.KidFighting.RoundGUI.show(com.KidFighting.RoundGUI.TIMEOUT,function()
            {
               com.KidFighting.RoundGUI.dispatchEvent({type:"nextRound"});
            }
            );
         }
         else
         {
            com.KidFighting.RoundGUI.show(com.KidFighting.RoundGUI.KO,function()
            {
               com.KidFighting.RoundGUI.dispatchEvent({type:"nextRound"});
            }
            );
         }
      }
      else if(evtObj.timeout)
      {
         if(evtObj.win == 0)
         {
            com.KidFighting.RoundGUI.show(com.KidFighting.RoundGUI.TIMEOUT,function()
            {
               com.KidFighting.RoundGUI.show(evtObj.winnerLable,function()
               {
                  com.KidFighting.RoundGUI.dispatchEvent({type:"nextRound"});
               }
               ,true);
            }
            );
         }
         else
         {
            com.KidFighting.RoundGUI.show(com.KidFighting.RoundGUI.TIMEOUT,function()
            {
               com.KidFighting.RoundGUI.show(evtObj.winnerLable,function()
               {
                  com.KidFighting.RoundGUI.dispatchEvent({type:"gameOver"});
               }
               ,false);
            }
            );
         }
      }
      else if(evtObj.win == 0)
      {
         com.KidFighting.RoundGUI.show(com.KidFighting.RoundGUI.KO,function()
         {
            com.KidFighting.RoundGUI.show(evtObj.winnerLable,function()
            {
               com.KidFighting.RoundGUI.dispatchEvent({type:"nextRound"});
            }
            ,true);
         }
         );
      }
      else
      {
         com.KidFighting.RoundGUI.show(com.KidFighting.RoundGUI.KO,function()
         {
            com.KidFighting.RoundGUI.show(evtObj.winnerLable,function()
            {
               com.KidFighting.RoundGUI.dispatchEvent({type:"gameOver"});
            }
            ,false);
         }
         );
      }
   }
}
