class com.KidFighting.Story
{
   static var addEventListener;
   static var dispatchEvent;
   static var history = [];
   static var mRnd = 1;
   static var _evt = mx.events.EventDispatcher.initialize(com.KidFighting.Story);
   static var _inited = com.KidFighting.Story.initialize();
   function Story()
   {
   }
   static function initialize()
   {
      com.KidFighting.Story.history.length = 0;
      com.KidFighting.Story.mRnd = 1;
      com.KidFighting.Story.reset();
      return true;
   }
   static function selectPlayer(evtObj)
   {
      var _loc1_ = com.KidFighting.CharacterManager.select(evtObj.id);
      if(_loc1_ != null)
      {
         com.KidFighting.FightTrigger.joinP1(_loc1_);
      }
   }
   static function selectEnemy(evtObj)
   {
      com.KidFighting.Story.nextEnemy();
   }
   static function updateSkill()
   {
      com.KidFighting.Story.dispatchEvent({type:"onUpdateSkill",skillList:com.KidFighting.FightTrigger.player1.skillList,maxShow:com.KidFighting.Story.history.length});
   }
   static function nextEnemy()
   {
      var _loc1_ = com.KidFighting.CharacterManager.selectNextEnemy();
      if(_loc1_ != null)
      {
         com.KidFighting.FightTrigger.joinP2(_loc1_);
         com.KidFighting.Story.mRnd = 1;
         com.KidFighting.Story.history.push({win:false,round:com.KidFighting.Story.mRnd});
         com.KidFighting.FightTrigger.player1.autoAddSkill();
         com.KidFighting.Story.updateSkill();
         com.KidFighting.Story.dispatchEvent({type:"onRoundInit",round:com.KidFighting.Story.mRnd,idPlayer1:com.KidFighting.FightTrigger.idPlayer1,idPlayer2:com.KidFighting.FightTrigger.idPlayer2,enemyId:com.KidFighting.Story.history.length});
      }
   }
   static function nextRound()
   {
      var _loc1_ = com.KidFighting.Story.history[com.KidFighting.Story.history.length - 1];
      if(_loc1_.win)
      {
         if(com.KidFighting.Story.history.length < 10)
         {
            com.KidFighting.Story.dispatchEvent({type:"onRoundCleared"});
         }
         else
         {
            com.KidFighting.Story.dispatchEvent({type:"onClearStage"});
         }
      }
      else
      {
         com.KidFighting.Story.mRnd = com.KidFighting.Story.mRnd + 1;
         _loc1_.round = com.KidFighting.Story.mRnd;
         com.KidFighting.Story.dispatchEvent({type:"onRoundInit",round:com.KidFighting.Story.mRnd,idPlayer1:com.KidFighting.FightTrigger.idPlayer1,idPlayer2:com.KidFighting.FightTrigger.idPlayer2});
      }
   }
   static function reset()
   {
      com.KidFighting.CharacterManager.reset();
      com.KidFighting.SelectCharacterGUI.reset();
      com.KidFighting.StageStatus.reset();
   }
   static function pauseGame(evtObj)
   {
      com.KidFighting.Story.dispatchEvent({type:"onPauseGame",value:evtObj.value});
   }
   static function endRound(evtObj)
   {
      if(evtObj.roundClear)
      {
         if(evtObj.win == 0)
         {
            com.KidFighting.Story.history[com.KidFighting.Story.history.length - 1].win = true;
         }
      }
      evtObj.type = "onRoundEnd";
      com.KidFighting.Story.dispatchEvent(evtObj);
   }
   static function fightStart(evtObj)
   {
      com.KidFighting.Story.dispatchEvent({type:"onFightStart"});
   }
   static function timeOut()
   {
      com.KidFighting.Story.dispatchEvent({type:"onTimeOut"});
   }
   static function gameOver()
   {
      com.KidFighting.Story.dispatchEvent({type:"onGameOver"});
   }
   static function updateLife(evtObj)
   {
      evtObj.type = "onUpdateLife";
      com.KidFighting.Story.dispatchEvent(evtObj);
   }
   static function switchMute(evtObj)
   {
      if(evtObj.value)
      {
         ds.controls.SoundPlayer.mute();
      }
      else
      {
         ds.controls.SoundPlayer.unmute();
      }
   }
   static function debug(evtObj)
   {
      if(evtObj.command == "prevPlayer")
      {
         if(com.KidFighting.Story.history.length > 0)
         {
            com.KidFighting.CharacterManager.selectedList.pop();
            com.KidFighting.CharacterManager.selectedList.pop();
         }
         com.KidFighting.Story.history.pop();
         com.KidFighting.Story.history.pop();
         com.KidFighting.Story.nextEnemy();
      }
      else if(evtObj.command == "nextPlayer")
      {
         com.KidFighting.Story.nextEnemy();
      }
      else if(evtObj.command == "traceStatus")
      {
         com.KidFighting.FightTrigger.player1.traceStatus();
         com.KidFighting.FightTrigger.player2.traceStatus();
      }
      else if(evtObj.command == "decLife")
      {
         com.KidFighting.FightTrigger.player2.crtHP = 1;
      }
   }
}
