class com.KidFighting.skills.SklIcecream extends com.KidFighting.objects.CSkill
{
   var name;
   var keys;
   var effStartFrame;
   var hurtValue;
   var type;
   var effect;
   var performing;
   var owner;
   var effect2;
   function SklIcecream()
   {
      super();
      this.name = "Icecream";
      this.keys = com.KidFighting.Input.LEFT + "," + com.KidFighting.Input.LEFT + "," + com.KidFighting.Input.S;
      this.effStartFrame = 3;
      this.hurtValue = 15;
      this.type = "flyItem";
   }
   function condition()
   {
      return !this.effect.performing && super.condition();
   }
   function perform()
   {
      this.performing = true;
      this.effect = com.KidFighting.EffectSys.generate(this.name,this.owner._twnF,this.owner,this.owner.ani._x + this.owner.side * 30,this.owner.orgY - 35);
      this.effect.effStartFrame = this.effStartFrame;
      this.effect.hurtValue = this.hurtValue;
      this.effect.skill = this;
      this.effect.looping = true;
      this.effect.movingSpeed = this.owner.side * this.effect.movingSpeed;
      this.effect.addEffectListener(this);
      ds.controls.SoundPlayer.playSound("BasicAttack_female");
   }
   function explode(x)
   {
      this.effect2 = com.KidFighting.EffectSys.generate("IcecreamSplash",null,this.owner,x,this.owner.orgY);
      this.effect2.addEffectListener(this);
   }
   function onMotionStopped()
   {
      this.effect.removeEffectListener(this);
      this.performing = false;
      this.owner.setSkillMotionFinished(this);
   }
}
