class com.KidFighting.skills.SklThrow extends com.KidFighting.objects.CSkill
{
   var name;
   var keys;
   var effStartFrame;
   var hurtValue;
   var type;
   var invincible;
   var owner;
   var performing;
   function SklThrow()
   {
      super();
      this.name = "Throw";
      this.keys = com.KidFighting.Input.A + "," + com.KidFighting.Input.S;
      this.effStartFrame = 6;
      this.hurtValue = 25;
      this.type = "self";
      this.invincible = true;
   }
   function condition()
   {
      return this.owner.opponent.getCoughtCondition();
   }
   function perform()
   {
      this.performing = true;
      this.owner.startInvincible(0.8);
      this.hurtValue = this.owner.strength * 3;
      this.owner.opponent.mtCought();
      if(this.owner.ani.getDepth() < this.owner.opponent.ani.getDepth())
      {
         this.owner.ani.swapDepths(this.owner.opponent.ani);
      }
      this.observeCharacterTween(this.owner._twnF);
      this.onMotionFinished = this.onMotionStopped;
      ds.controls.SoundPlayer.playSound("BasicAttack_" + this.owner.sex);
   }
   function onMotionUpdated(twn)
   {
      if(twn.obj._currentframe == this.effStartFrame)
      {
         this.owner.dispatchEvent({type:"onFightActivated",activer:this.owner,getHurt:true,hitEff:"nothing",hurtValue:this.hurtValue,isNoAnimation:true});
         this.owner.opponent.mtThrown();
         this.owner.opponent.updateSide(this.owner.side);
         this.owner.updateSide(- this.owner.side);
         if(this.owner.isOnEdge(20))
         {
            this.owner.correctPosition();
         }
      }
   }
   function onMotionStopped()
   {
      this.unobserveCharacterTween(this.owner._twnF);
      this.performing = false;
      this.owner.setSkillMotionFinished(this);
   }
}
